clear all; close all;

% n. di piani = 5
m=0.5*10; h=0.1; k=0.6;

%%%%%%%%% senza la sfera %%%%%%%%%
A=[0 0 0 0 0 1 0 0 0 0
   0 0 0 0 0 0 1 0 0 0
   0 0 0 0 0 0 0 1 0 0
   0 0 0 0 0 0 0 0 1 0
   0 0 0 0 0 0 0 0 0 1
   -2*k/m k/m 0 0 0 -h/m 0 0 0 0
   k/m -2*k/m k/m 0 0 0 -h/m 0 0 0
   0 k/m -2*k/m k/m 0 0 0 -h/m 0 0 
   0 0 k/m -2*k/m k/m 0 0 0 -h/m 0 
   0 0 0 k/m -k/m 0 0 0 0 -h/m];
% l'ingresso  la forza applicata al piano primo
b=[0 0 0 0 0 1/m 0 0 0 0]';
% misuro le posizioni di tutti i piani
cTOT=[1 0 0 0 0 0 0 0 0 0
      0 1 0 0 0 0 0 0 0 0
      0 0 1 0 0 0 0 0 0 0
      0 0 0 1 0 0 0 0 0 0
      0 0 0 0 1 0 0 0 0 0];
% % Diagrammi di Bode dall'ingresso u alla posizione del penultimo piano
sistema0=ss(A,b,cTOT(4,:),0);
% bode(sistema0); grid; axis([0.01 1 -100 20]);
% pause;
% % Ingresso periodico con pulsazione pari a 0.1
t=[0:1:600];
omega=0.1; u=sin(omega*t);
sistema0_TOT=ss(A,b,cTOT,0);
Y0=lsim(sistema0_TOT,u,t);
% figure; plot(t,Y0(:,4)); axis([0 600 -10 10]); xlabel('t'); ylabel('penultimo piano');
% figure; plot(t,Y0); axis([0 600 -10 10]); xlabel('t'); ylabel('tutti i piani');
% pause; close all;

%%%%%%%%% con la sfera %%%%%%%%%
% lo smorzatore (sfera) agisce sul penultimo piano (q=coefficiente di attrito dello smorzatore)
q=2;
A=[0 0 0 0 0 1 0 0 0 0
   0 0 0 0 0 0 1 0 0 0
   0 0 0 0 0 0 0 1 0 0
   0 0 0 0 0 0 0 0 1 0
   0 0 0 0 0 0 0 0 0 1
   -2*k/m k/m 0 0 0 -h/m 0 0 0 0
   k/m -2*k/m k/m 0 0 0 -h/m 0 0 0
   0 k/m -2*k/m k/m 0 0 0 -h/m 0 0 
   0 0 k/m -2*k/m k/m 0 0 0 -h/m-q/m 0 
   0 0 0 k/m -k/m 0 0 0 0 -h/m];
% % Diagrammi di Bode dall'ingresso u alla posizione del penultimo piano
sistemaq=ss(A,b,cTOT(4,:),0);
% bode(sistemaq); grid; axis([0.01 1 -100 20]);
% pause;
% % Ingresso periodico con pulsazione pari a 0.1
sistemaq_TOT=ss(A,b,cTOT,0);
Yq=lsim(sistemaq_TOT,u,t);
% figure; plot(t,Yq(:,4)); axis([0 600 -10 10]); xlabel('t'); ylabel('penultimo piano');
% figure; plot(t,Yq); axis([0 600 -10 10]); xlabel('t'); ylabel('tutti i piani');
% pause; close all;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Simulazione stilizzata piani senza sfera (sinistra) e con sfera (destra)
figure; axis([-13 13 0 6]); hold on;
x0=0*ones(size(t));
x1=1*ones(size(t));
x2=2*ones(size(t));
x3=3*ones(size(t));
x4=4*ones(size(t));
x5=5*ones(size(t));
for k = 5:length(t)
    subplot(1,2,1);plot([u(k) Y0(k,1) Y0(k,2) Y0(k,3) Y0(k,4) Y0(k,5)],[x0(k) x1(k) x2(k) x3(k) x4(k) x5(k)],'-k','LineWidth',3); axis([-13 13 0 6]);
    subplot(1,2,2);plot([u(k) Yq(k,1) Yq(k,2) Yq(k,3) Yq(k,4) Yq(k,5)],[x0(k) x1(k) x2(k) x3(k) x4(k) x5(k)],'-k','LineWidth',3); axis([-13 13 0 6]);pause(0.000001);
    clf;
end
