clear all; close all;
% Filtro "a spillo" - notch filter
% serie R L C alimentato in tensione - uscita = tensione ai capi di L-C
f0=1000; deltaf0=200;
w0=2*pi*f0;
deltaB=2*pi*deltaf0;
L=1/w0; C=L; R=2*pi*L*deltaB;

A=[-R/L -1/L;1/C 0];
b=[1/L 0]';
c=[-R 0];
d=1;
[NUM,DEN]=ss2tf(A,b,c,d);
filtro=tf(NUM,DEN);
figure(1);bode(filtro); xlim([10^2 10^6]); grid;
pause; close;

% creo un segnale con frequenza che varia da Fmin a Fmax
Fmin=800; Fmax=1210;
t=0:6/100000:6;
figure(2);
subplot(1,2,1); axis([0 6 -1.1 1.1]); xlabel('t'); ylabel('u'); title('ingresso sweep'); hold on;
subplot(1,2,2);axis([0.01 6 -1.1 1.1]); xlabel('t'); ylabel('y'); title('uscita'); hold on;
pause;
us=chirp(t,Fmin,6,Fmax);
sound(us,100000/6); pause; subplot(1,2,1); plot(t,us);
pause;

% Uscita sonora dal filtro a spillo
Yfiltro=lsim(filtro,us,t);
[MOD,PH]=bode(filtro,2*pi*Fmin);
Yfiltro=Yfiltro/MOD;
sound(Yfiltro,100000/6); pause; subplot(1,2,2); plot(t,Yfiltro); 
pause; close;

% Oppure sento e vedo come passano sinusoidi a frequenza fissa 

freq=800; % passa bene
% ingresso
t=0:2/20000:2;
us=sin(2*pi*freq*t);
figure(3); title('uscita con ingresso a frequenza 800 Hz = 5e+03 rad/sec'); axis([0.01 2 -1.1 1.1]); pause; hold on;
sound(us,20000/2); pause;
Yfiltro=lsim(filtro,us,t);
[MOD,PH]=bode(filtro,2*pi*Fmin);
Yfiltro=Yfiltro/MOD;
figure(3); 
sound(Yfiltro,20000/2); pause;
plot(t,Yfiltro); pause; close;

freq=1000; % viene filtrata
% ingresso
t=0:2/20000:2;
us=sin(2*pi*freq*t);
figure(4); title('uscita con ingresso a frequenza 1000 Hz = 6.28e+03 rad/sec'); axis([0.01 2 -1.1 1.1]); pause; hold on;
sound(us,20000/2); pause;
Yfiltro=lsim(filtro,us,t);
[MOD,PH]=bode(filtro,2*pi*Fmin);
Yfiltro=Yfiltro/MOD;
figure(4); 
sound(Yfiltro,20000/2); pause;
plot(t,Yfiltro); pause; close;

freq=1250; % passa bene
% ingresso
t=0:2/20000:2;
us=sin(2*pi*freq*t);
figure(5); title('uscita con ingresso a frequenza 800 Hz = 7.8e+03 rad/sec'); axis([0.01 2 -1.1 1.1]); pause; hold on;
sound(us,20000/2); pause;
Yfiltro=lsim(filtro,us,t);
[MOD,PH]=bode(filtro,2*pi*Fmin);
Yfiltro=Yfiltro/MOD;
figure(5); 
sound(Yfiltro,20000/2); pause;
plot(t,Yfiltro); pause; close;